﻿// This plugin is entirely made possible by xfox from the HB forums
// He let me use all his server code

using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;
using System.Timers;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Imaging;

using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Common.Plugins;
using Buddy.Swtor;
using Buddy.Swtor.Objects;

using Action = Buddy.BehaviorTree.Action;



namespace Buddywing.Plugins
{
    public class ExMonitor : IPlugin
    {

        public bool Equals(IPlugin other)
        {
            return other.Name == Name;
        }

        public string Author { get { return "Exmortem // MASSIVE thanks to Fox"; } }

        public Version Version { get { return new Version(1, 0); } }

        public string Name { get { return "ExMonitor"; } }

        public string Description { get { return "Simple monitoring plugin for BW"; } }

        public Window DisplayWindow { get { return null; } }

        Stopwatch watch = new Stopwatch();

		int timeToUpDateFileFromData = 15;

        //Get Window Handle
        [DllImport("User32.dll")]
        public static extern Int32 FindWindow(String lpClassName, String lpWindowName);

        public IntPtr GetHandle()
        {
            return (IntPtr)FindWindow(null, "Star Wars™: The Old Republic™");
        }

        string templateFile = "Plugins/ExMonitor/template.html";
        string realFile = "Plugins/ExMonitor/index.html";

        string templateFileContent;
        string realFileContent;
        string tempString;

        ScreenCapture sc = new ScreenCapture();
        Thread serverthread;

        private void Log(string message)
        {

        }

        /// <summary> Executes the pulse action. This is called every "tick" of the bot. </summary>
        public void OnPulse()
        {
            if (!watch.IsRunning)
            {
                watch.Start();
                upDateFileFromData();
                sc.CaptureWindowToFile((IntPtr)FindWindow(null, "Star Wars™: The Old Republic™"), "Plugins/ExMonitor/images/" + BuddyTor.Me.Name + ".jpg", ImageFormat.Jpeg);
            }
            if (watch.Elapsed.TotalSeconds > timeToUpDateFileFromData)
            {
                watch.Reset();
                watch.Start();
                upDateFileFromData();
                sc.CaptureWindowToFile((IntPtr)FindWindow(null, "Star Wars™: The Old Republic™"), "Plugins/ExMonitor/images/" + BuddyTor.Me.Name + ".jpg", ImageFormat.Jpeg);
            }
        }

        /// <summary> Executes the initialize action. This is called at initial bot startup. (When the bot itself is started, not when Start() is called) </summary>
        public void OnInitialize()
        {
          serverthread = new Thread(new ThreadStart(StartServer));
        }

        /// <summary> Executes the shutdown action. This is called when the bot is shutting down. (Not when Stop() is called) </summary>
        public void OnShutdown()
        {
            try
            {
                serverthread.Abort();
            }
            catch (Exception e)
            {
                Logging.Write(String.Format("[ExMonitor] error closing socket: {0}", e));
            }
        }

        /// <summary> Executes the enabled action. This is called when the user has enabled this specific plugin via the GUI. </summary>
        public void OnEnabled()
        {
          serverthread.Start();
        }

        /// <summary> Executes the disabled action. This is called whent he user has disabled this specific plugin via the GUI. </summary>
        public void OnDisabled()
        {
            try
            {
                serverthread.Interrupt();
            }
            catch (Exception e)
            {
                Logging.Write(String.Format("[ExMonitor] error interrupting socket: {0}", e));
            }
        }

        #region Modified Fox Server

        private void StartServer()
        {
            FoxServer server1 = new FoxServer(4444, 4445);
        }

        private void upDateFileFromData()
        {
            //Logging.Write("[ExMonitor]: Updating HTML file");
            readTemplateFile();
            fillTemplateFileWithContent();
            writeRealFile();
            //Logging.Write("[ExMonitor]: Update finished");
        }
        private void readTemplateFile()
        {
            templateFileContent = ReadFile(templateFile);
        }
        private void fillTemplateFileWithContent()
        {

            double myExperience = Convert.ToDouble(BuddyTor.Me.Xp);
            double neededExperience = Convert.ToDouble(BuddyTor.Me.XpNeeded);
            double percent = myExperience / (neededExperience / 100);
                                           
            tempString = "";
            tempString = templateFileContent;
            tempString = tempString.Replace("##name##", BuddyTor.Me.Name.ToString());
            tempString = tempString.Replace("##zone##", BuddyTor.Me.CurrentAreaVisited.ToString());
            tempString = tempString.Replace("##percenttillvl##", Math.Round(100 - percent, 0).ToString());
            tempString = tempString.Replace("##level##", BuddyTor.Me.Level.ToString());
            tempString = tempString.Replace("##class##", BuddyTor.Me.Class.ToString() + "  " + BuddyTor.Me.AdvancedClass.ToString());
            tempString = tempString.Replace("##health##", Math.Round(BuddyTor.Me.HealthPercent, 1).ToString());
            tempString = tempString.Replace("##healthpercent##", Math.Round(100 - BuddyTor.Me.HealthPercent, 0).ToString());
          
            //Normal XP
            tempString = tempString.Replace("##percent##", Math.Round(percent, 2).ToString());
            tempString = tempString.Replace("##neededExperience##", neededExperience.ToString());
            tempString = tempString.Replace("##xptolvl##", Math.Round(neededExperience - myExperience, 0).ToString());
            tempString = tempString.Replace("##myExperience##", myExperience.ToString());
            tempString = tempString.Replace("##percenttillvl##", Math.Round(100 - percent, 0).ToString());
        
            realFileContent = tempString;
            tempString = String.Empty;
        }

        public void writeRealFile()
        {
            StreamWriter myFile = new StreamWriter(realFile);
            myFile.Write(realFileContent);
            myFile.Close();
        }

        private string ReadFile(String Filename)
        {
            string Content = "";

            if (File.Exists(Filename))
            {
                StreamReader myFile = new StreamReader(Filename, System.Text.Encoding.Default);
                Content = myFile.ReadToEnd();
                myFile.Close();
            }
            return Content;
        }
      
        class FoxServer
        {
            public FoxServer(int Port, int Backlog)
            {
                Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                server.Bind(new IPEndPoint(IPAddress.Any, Port));
                server.Listen(Backlog);
                while (true)
                {
                    Socket sock = server.Accept();
                    ServerHandling handling = new ServerHandling(sock);
                    Thread clientthread = new Thread(new ThreadStart(handling.Run));
                    clientthread.Start();
                }
            }
        }

        class ServerHandling
        {
            public ServerHandling(Socket socket)
            {
                this.socket = socket;
            }

            public void Run()
            {
                String request = getContent();
                try
                {
                    String[] lines = request.Split(Environment.NewLine.ToCharArray());
                    String[] words = lines[0].Split(" ".ToCharArray());
                    if (words[0] == "GET")
                    {
                        int pos = words[1].LastIndexOf("/");
                        if (pos > -1)
                        {
                            if (words[1] != "/" && words[1].Length > pos)
                            {
                                String filename = words[1].Substring(pos + 1);
                                String extension = Path.GetExtension(filename);

                                if (extension == ".htm" || extension == ".html")
                                {
                                    if (File.Exists("Plugins/ExMonitor/" + filename))
                                    {
                                        sendFile(filename);
                                    }
                                    else
                                    {
                                        sendResponse("404 NOT FOUND", "Datei nicht gefunden");
                                    }
                                }
                                else
                                {
                                    if (File.Exists("Plugins/ExMonitor/images/" + BuddyTor.Me.Name + ".jpg"))
                                    {
                                        sendFile("Plugins/ExMonitor/images/" + BuddyTor.Me.Name + ".jpg");
                                    }
                                    else
                                    {
                                        sendResponse("404 NOT FOUND", "Datei nicht gefunden");
                                    }
                                }
                            }
                            else
                            {
                                if (File.Exists("Plugins/ExMonitor/" + "index.html"))
                                    sendFile("Plugins/ExMonitor/" + "index.html");
                                else
                                    sendResponse("200 OK", "No File Created Yet ! Please wait 30 seconds!");
                            }
                          
                         }
                        else
                        {
                            sendResponse("400 BAD REQUEST", "Protokollfehler");
                        }
                    }
                    else
                    {
                        sendResponse("400 BAD REQUEST", "Nicht unterstützt");
                    }
                }
                catch
                {
                    sendResponse("400 BAD REQUEST", "Protokollfehler");
                }
                socket.Close();
            }

            private void sendResponse(string status, string tosend)
            {
                LogConsole(status);
                sendText("HTTP/1.1 " + status);
                sendText("Server: ExMonitor / BW");
                sendText("Connection: close");
                sendText("Content-Type: text/html");
                sendText("Content-Length: " + (tosend.Length + Environment.NewLine.Length));
                sendText("");
                sendText(tosend);
            }

            private string determineContentType(string filename)
            {
                string extension = Path.GetExtension(filename);
                switch (extension)
                {
                    case ".jpg":
                        return @"image/jpeg";

                    case ".htm":
                    case ".html":
                        return @"text/html";
                }

                return "application/octet-stream";
            }


            private void sendText(String text)
            {
                socket.Send(Encoding.UTF8.GetBytes(text + Environment.NewLine));
            }

            private void LogConsole(string message)
            {
                Console.WriteLine(((IPEndPoint)socket.RemoteEndPoint).Address.ToString() + " - " + message);
            }

            private void sendFile(string filename)
            {
                FileStream stream = new FileStream(filename, FileMode.Open);
                LogConsole("200 OK [" + filename + "]");
                sendText("HTTP/1.1 200 OK");
                sendText("Server: ExMonitor / BW");
                sendText("Connection: close");
                sendText("Content-Type: " + determineContentType(filename));
                sendText("Content-Length: " + stream.Length);
                sendText("");
                long read = 0;
                while (read < stream.Length)
                {
                    int buffersize;
                    if (stream.Length - read > 1024)
                    {
                        buffersize = 1024;
                        read += 1024;
                    }
                    else
                    {
                        buffersize = (int)(stream.Length - read);
                        read = stream.Length;
                    }
                    byte[] tosend = new byte[buffersize];
                    stream.Read(tosend, 0, buffersize);
                    socket.Send(tosend);
                    Thread.Sleep(1);
                }
                stream.Close();
            }

            private String getContent()
            {
                String content = "";
                Thread.Sleep(10);
                while (socket.Available > 0)
                {
                    int bytes = socket.Available;
                    byte[] buffer = new byte[bytes];
                    socket.Receive(buffer, bytes, SocketFlags.None);
                    content += Encoding.UTF8.GetString(buffer);
                    Thread.Sleep(10);
                }
                return content;
            }
                                  
               Socket socket;
        }
        #endregion
        #region Screenshot
        public class ScreenCapture
        {
            /// <summary>
            /// Creates an Image object containing a screen shot of the entire desktop
            /// </summary>
            /// <returns></returns>
            public Image CaptureScreen()
            {
                return CaptureWindow(User32.GetDesktopWindow());
            }
            /// <summary>
            /// Creates an Image object containing a screen shot of a specific window
            /// </summary>
            /// <param name="handle">The handle to the window. (In windows forms, this is obtained by the Handle property)</param>
            /// <returns></returns>
            public Image CaptureWindow(IntPtr handle)
            {
                // get te hDC of the target window
                IntPtr hdcSrc = User32.GetWindowDC(handle);
                // get the size
                User32.RECT windowRect = new User32.RECT();
                User32.GetWindowRect(handle, ref windowRect);
                int width = windowRect.right - windowRect.left;
                int height = windowRect.bottom - windowRect.top;
                // create a device context we can copy to
                IntPtr hdcDest = GDI32.CreateCompatibleDC(hdcSrc);
                // create a bitmap we can copy it to,
                // using GetDeviceCaps to get the width/height
                IntPtr hBitmap = GDI32.CreateCompatibleBitmap(hdcSrc, width, height);
                // select the bitmap object
                IntPtr hOld = GDI32.SelectObject(hdcDest, hBitmap);
                // bitblt over
                GDI32.BitBlt(hdcDest, 0, 0, width, height, hdcSrc, 0, 0, GDI32.SRCCOPY);
                // restore selection
                GDI32.SelectObject(hdcDest, hOld);
                // clean up 
                GDI32.DeleteDC(hdcDest);
                User32.ReleaseDC(handle, hdcSrc);
                // get a .NET image object for it
                Image img = Image.FromHbitmap(hBitmap);
                // free up the Bitmap object
                GDI32.DeleteObject(hBitmap);
                return img;
            }
            /// <summary>
            /// Captures a screen shot of a specific window, and saves it to a file
            /// </summary>
            /// <param name="handle"></param>
            /// <param name="filename"></param>
            /// <param name="format"></param>
            public void CaptureWindowToFile(IntPtr handle, string filename, ImageFormat format)
            {
                Image img = CaptureWindow(handle);
                img.Save(filename, format);
            }
            /// <summary>
            /// Captures a screen shot of the entire desktop, and saves it to a file
            /// </summary>
            /// <param name="filename"></param>
            /// <param name="format"></param>
            public void CaptureScreenToFile(string filename, ImageFormat format)
            {
                Image img = CaptureScreen();
                img.Save(filename, format);
            }

            /// <summary>
            /// Helper class containing Gdi32 API functions
            /// </summary>
            private class GDI32
            {

                public const int SRCCOPY = 0x00CC0020; // BitBlt dwRop parameter
                [DllImport("gdi32.dll")]
                public static extern bool BitBlt(IntPtr hObject, int nXDest, int nYDest,
                    int nWidth, int nHeight, IntPtr hObjectSource,
                    int nXSrc, int nYSrc, int dwRop);
                [DllImport("gdi32.dll")]
                public static extern IntPtr CreateCompatibleBitmap(IntPtr hDC, int nWidth,
                    int nHeight);
                [DllImport("gdi32.dll")]
                public static extern IntPtr CreateCompatibleDC(IntPtr hDC);
                [DllImport("gdi32.dll")]
                public static extern bool DeleteDC(IntPtr hDC);
                [DllImport("gdi32.dll")]
                public static extern bool DeleteObject(IntPtr hObject);
                [DllImport("gdi32.dll")]
                public static extern IntPtr SelectObject(IntPtr hDC, IntPtr hObject);
            }

            /// <summary>
            /// Helper class containing User32 API functions
            /// </summary>
            private class User32
            {
                [StructLayout(LayoutKind.Sequential)]
                public struct RECT
                {
                    public int left;
                    public int top;
                    public int right;
                    public int bottom;
                }
                [DllImport("user32.dll")]
                public static extern IntPtr GetDesktopWindow();
                [DllImport("user32.dll")]
                public static extern IntPtr GetWindowDC(IntPtr hWnd);
                [DllImport("user32.dll")]
                public static extern IntPtr ReleaseDC(IntPtr hWnd, IntPtr hDC);
                [DllImport("user32.dll")]
                public static extern IntPtr GetWindowRect(IntPtr hWnd, ref RECT rect);
            }
        }
        #endregion
    }
}